
/** @file tinfo.h
 *
 * Values for GiNaC's run-time type information scheme
 *
 */

/*
 *  Copyright (C) 2001 Stefan Weinzierl
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __NESTEDSUMS_TINFO_H__
#define __NESTEDSUMS_TINFO_H__

#include "ginac/ginac.h"

namespace GiNaC {

  //  const unsigned TINFO_basic_nestedsum          = 0x01000000U;
  //  const unsigned TINFO_basic_Ztype_sum          = 0x01000001U;
  //  const unsigned TINFO_basic_Stype_sum          = 0x01000002U;

  const unsigned TINFO_Zsum                      = 0x01000003U;
  const unsigned TINFO_Ssum                      = 0x01000004U;
  const unsigned TINFO_Csum                      = 0x01000005U;
  const unsigned TINFO_Bsum                      = 0x01000006U;

  const unsigned TINFO_Euler_Zagier_sum          = 0x01000007U;
  const unsigned TINFO_harmonic_sum              = 0x01000008U;

  const unsigned TINFO_multiple_polylog          = 0x01000009U;
  const unsigned TINFO_harmonic_polylog          = 0x0100000aU;
  const unsigned TINFO_nielsen_polylog           = 0x0100000bU;
  const unsigned TINFO_classical_polylog         = 0x0100000cU;

  const unsigned TINFO_multiple_zeta_value       = 0x0100000dU;

  const unsigned TINFO_Ssum_to_Infinity          = 0x0100000eU;
  const unsigned TINFO_harmonic_sum_to_Infinity  = 0x0100000fU;

  const unsigned TINFO_basic_letter              = 0x01000010U;
  const unsigned TINFO_letter                    = 0x01000011U;
  const unsigned TINFO_unit_letter               = 0x01000012U;

  const unsigned TINFO_ratio_of_tgamma           = 0x01000015U;
  const unsigned TINFO_list_of_tgamma            = 0x01000016U;

  const unsigned TINFO_transcendental_sum_type_A = 0x0100001aU;
  const unsigned TINFO_transcendental_sum_type_B = 0x0100001bU;
  const unsigned TINFO_transcendental_sum_type_C = 0x0100001cU;
  const unsigned TINFO_transcendental_sum_type_D = 0x0100001dU;

  const unsigned TINFO_transcendental_fct_type_A = 0x01000020U;
  const unsigned TINFO_transcendental_fct_type_B = 0x01000021U;
  const unsigned TINFO_transcendental_fct_type_C = 0x01000022U;
  const unsigned TINFO_transcendental_fct_type_D = 0x01000023U;

  const unsigned TINFO_hash_entry                = 0x01000030U;

} // namespace GiNaC

#endif // ndef __NESTEDSUMS_TINFO_H__









